Subject: bug#749: initscripts: /etc/init.d/halt calls halt with unsupported options

From: Mark Hindley <[email-masked]>
Date: Wed, 8 Mar 2023 12:43:30 +0000

Olaf,

On Wed, Mar 08, 2023 at 08:44:01PM +0900, Olaf Meeuwissen wrote:
> Package: initscripts
> Version: 3.06-2devuan1
> Severity: normal
> X-Debbugs-Cc: none, Olaf Meeuwissen <[email-masked]>
> 
> Dear Maintainer,
> 
> Every time I `poweroff` my machine, I see error message flash by that
> complain about `halt` being called with unsupported options.  I think
> I have tracked this down to /etc/init.d/halt making blind assumptions
> about the options supported by the `halt` command.

Thanks. We keep bumping into issues similar to this with the different halt
implementations.

I don't immediately have a really good solution.

> Said command may be provided by any of a number of packages.  A quick
> `apt-file search sbin/halt` turns up
> 
>   $ apt-file search sbin/halt
>   bfh-container: /sbin/halt
>   finit-sysv: /sbin/halt
>   molly-guard: /sbin/halt
>   progress-linux-container: /sbin/halt
>   runit-init: /sbin/halt
>   systemd-sysv: /sbin/halt
>   sysvinit-core: /sbin/halt
> 
> Mine happens to be
> 
>   $ ls -l /sbin/halt
>   lrwxrwxrwx 1 root root 19 Feb 10 03:45 /sbin/halt -> /lib/runit/shutdown
> 
> where the symlink target is from the runit package.  According to the
> manual page, my halt command only supports -f, -w and -n short options.

My gut reaction is that runit's halt should either support the sysvinit options
even if noop.

Lorenzo,

I have no real experience of runit yet. What is the relationship between it an
initscripts? When are the initscripts used? Is there something you can do within
src:runit to avoid this?

Thanks

Mark